# bin
My Linux `~/bin` folder, including my `.bashrc` and `.bash_aliases`.

This repository will contain all the various tools and / or commands I find that I put in my `~/bin` folder.

Here's a list of the most interesting ones, along with what they do and where they came from (assuming I can find / remember):

 - [style](https://github.com/LuRsT/style) - Add style to your output
 - [hr](https://github.com/LuRsT/hr) - A horizontal ruler for your terminal
 - [dropbox_uploader.sh](https://github.com/andreafabrizi/Dropbox-Uploader) - Dropbox Uploader is a BASH script which can be used to upload, download, list or delete files from Dropbox.
 - swapusage - Shows swap usage by process. Useful for determining which services to restart if you aren't allowed to fiddle with your swap.
 - extract - Extracts several different types of archive.
 - mail-service-restart - Restarts all service related to my mail server. Currently needs upgrading to use systemd.
 - decrypt - Decrypts something encrypted with a password with openssl.
 - encrypt - Encrpyts something with a password with openssl.
 - splitdotmbox.sh - Splits a `.mbox` file into it's component messages
 - ctx - Shows contact switches by process in real time
 - ps_mem - Shows memory usage by process.
 - node-update - Adapted from a bash script given in a github issue for io.js, this script will update you to the latest version of node. I think that there's a bug with it, but it works well enough for me.
 - stealtime - Tells you how much of your CPU time has been stolen by other virtual machines.
 - [speedtest-cli](https://github.com/sivel/speedtest-cli)
 - mountunishares - A script that automatically mounts my university file shares.
 - pd - A directory stack helper. Insanely useful - I think I picked it up from a superuser answer somewhere.
 - [transfer](https://transfer.sh/) - A look that looks very useful. Like termbin.com, but for any kind of file. Keeps files for 14 days, and has an uppder limit of 5GB.
 - [xidel](http://www.videlibri.de/xidel.html) - A (what looks like) a brilliant html extraction tool. Supports various selector languages.
 - [micro](https://github.com/zyedidia/micro) - A new (experimental) terminal-based text editor.
 - [tig](http://jonas.nitro.dk/tig/) - A terminal-based git repository browser.
 - backup - A script I wrote to make using Duplicity easier.
 - genimagecomparisonframes - Another script I wrote to generate the frames for the first half of [this video](https://starbeamrainbowlabs.com/blog/images/20160525-Tessellator-Comparison.webm).
 - [dtach](http://dtach.sourceforge.net/) - A minimal alternative to `screen` and `tmux`.
 - [commacd](https://github.com/shyiko/commacd) - A faster way to move around.
 - drop_pagecache - A quick script I wrote to drop the linux page cache.
 - [hastebin](https://gist.github.com/flores/3670953) - A [hastebin](http://hastebin.com/) CLI.
 - [quickshare](https://github.com/netham91/Quick-Share) - A quick way to share files via HTTP.
 - [cscz](https://git.starbeamrainbowlabs.com/sbrl/cscz) - The one and only C# class generator. A little timesaving tool I built myself, written in C# or course :D
 - [repren](https://github.com/jlevy/repren) - A good bulk file renaming tool.
 - [goldilocks](http://unix.stackexchange.com/a/124460/64687) - A script that displays all of the possible terminal colours.
 - [catimg](https://github.com/posva/catimg) - A cool script to display images in the terminal. Useful when you're sshing into servers.
 - [tldr](https://github.com/raylee/tldr) - A bash client for 
[tldr-pages](https://github.com/tldr-pages/tldr).
 - [git ignore](https://gitignore.io/) - A really useful subcommand for git that allows you to generate ignore files automagically.
 - organise-photos - A small bash script I wrote that organises the photos in a directory by year & month.

## Disclaimer
I don't own many of the tools in this repository. If you are an owner of one of these tools and I haven't linked to you, please let me know as I probably forgot.
